import MongoConnector from './mongo_connector';
import * as Random from 'meteor-random';
import { Collection, FindOneOptions, Cursor, ReplaceOneOptions, InsertOneWriteOpResult, UpdateWriteOpResult } from 'mongodb';
export default class MongoEntity<T> {
    connector: MongoConnector;
    random: typeof Random;
    private _collectionName;
    private _collection;
    private _singleLoader;
    private _multiLoader;
    readonly collection: Collection<T>;
    constructor(connector: MongoConnector, collectionName: string);
    clearUpdateCaches(selector: any): void;
    clearInsertCaches(selector: Object): void;
    find(selector: Object, fields?: Object, skip?: number, limit?: number, timeout?: number): Cursor<T>;
    findOne(selector: Object, options?: FindOneOptions): Promise<T>;
    findOneCachedById(id: string): Promise<T>;
    findManyCached(): Promise<T[]>;
    insert(document: T): Promise<InsertOneWriteOpResult>;
    update(selector: Object, update: Object, options?: ReplaceOneOptions): Promise<UpdateWriteOpResult>;
}
